﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.IO;

namespace Actions
{
    public enum PendingActionResult
    {
        LeavePendingActionInPlace,
        ClearPendingAction
    }
    public class MultiModalReactions
    {
        public static PendingActionResult ActOnMultiModalInput(int eval)
        {
            switch (eval)
            {
                case 0:
                    // 0 represents a non-complete scenario => return
                    return PendingActionResult.LeavePendingActionInPlace;
                    break;
                case 17:
                    //button #1  action:PlayAudio
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 18:
                    //button #1  action:PlayVideo
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play video.");
                    break;
                case 19:
                    //button #1  action:PowerPoint
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to open a power point presentation.");
                    break;
                case 20:
                    //button #1  action:Word
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 21:
                    //button #1  action:Excel
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 22:
                    //button #1  action:Project
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 23:
                    //button #1  action:Undefined
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 33:
                    //button #2  action:PlayAudio
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 34:
                    //button #2  action:PlayVideo
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 35:
                    //button #2  action:PowerPoint
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 36:
                    //button #2  action:Word
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 37:
                    //button #2  action:Excel
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 38:
                    //button #2  action:Project
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 39:
                    //button #2  action:Undefined
                    GeneralActions.Speak("To illustrate the point, I understand you selected button one and intended to play audio.");
                    break;
                case 49:
                    //button #3  action:PlayAudio
                    GeneralActions.Speak("To illustrate the point, I understand you selected button three and intended to play audio.");
                    break;
                case 50:
                    //button #3  action:PlayVideo
                    GeneralActions.Speak("To illustrate the point, I understand you selected button three and intended to play a video.");
                    break;
                case 51:
                    //button #3  action:PowerPoint
                    GeneralActions.Speak("To illustrate the point, I understand you selected button three and intended to open a power point presentation.");
                    break;
                case 52:
                    //button #3  action:Word
                    GeneralActions.Speak("To illustrate the point, I understand you selected button three and intended to open a word document.");
                    break;
                case 53:
                    //button #3  action:Excel
                    GeneralActions.Speak("To illustrate the point, I understand you selected button three and intended to open a spreadsheet.");
                    break;
                case 54:
                    //button #3  action:Project
                    GeneralActions.Speak("To illustrate the point, I understand you selected button three and intended to open a project plan.");
                    break;
                case 55:
                    //button #3  action:Undefined
                    GeneralActions.Speak("To illustrate the point, I understand you selected button three and intended to execute the undefined function.");
                    break;
                case 65:
                    //button #4  action:PlayAudio
                    GeneralActions.Speak("To illustrate the point, I understand you selected button four and intended to play audio.");
                    break;
                case 66:
                    //button #4 action:PlayVideo
                    GeneralActions.Speak("To illustrate the point, I understand you selected button four and intended to play video.");
                    break;
                case 67:
                    //button #4  action:PowerPoint
                    GeneralActions.Speak("To illustrate the point, I understand you selected button four and intended to open a power point presentation.");
                    break;
                case 68:
                    //button #4  action:Word
                    GeneralActions.Speak("To illustrate the point, I understand you selected button four and intended to open a word document.");
                    break;
                case 69:
                    //button #4  action:Excel
                    GeneralActions.Speak("To illustrate the point, I understand you selected button four and intended to open a spreadsheet.");
                    break;
                case 70:
                    //button #4  action:Project
                    GeneralActions.Speak("To illustrate the point, I understand you selected button four and intended to open a project plan.");
                    break;
                case 71:
                    //button #4  action:Undefined
                    GeneralActions.Speak("To illustrate the point, I understand you selected button four and intended to execute the undefined function.");
                    break;
                case 81:
                    //button #5  action:PlayAudio
                    GeneralActions.Speak("To illustrate the point, I understand you selected button five and intended to play audio.");
                    break;
                case 82:
                    //button #5  action:PlayVideo
                    GeneralActions.Speak("To illustrate the point, I understand you selected button five and intended to play video.");
                    break;
                case 83:
                    //button #5  action:PowerPoint
                    GeneralActions.Speak("To illustrate the point, I understand you selected button five and intended to open a power point presentation.");
                    break;
                case 84:
                    //button #5  action:Word
                    GeneralActions.Speak("To illustrate the point, I understand you selected button five and intended to open a word document.");
                    break;
                case 85:
                    //button #5  action:Excel
                    GeneralActions.Speak("To illustrate the point, I understand you selected button five and intended to open a spreadsheet.");
                    break;
                case 86:
                    //button #5  action:Project
                    GeneralActions.Speak("To illustrate the point, I understand you selected button five and intended to open a project plan.");
                    break;
                case 87:
                    //button #5  action:Undefined
                    GeneralActions.Speak("To illustrate the point, I understand you selected button five and intended to execute the undefined function.");
                    break;
                case 97:
                    //button #6  action:PlayAudio
                    GeneralActions.Speak("To illustrate the point, I understand you selected button six and intended to play audio.");
                    break;
                case 98:
                    //button #6  action:PlayVideo
                    GeneralActions.Speak("To illustrate the point, I understand you selected button six and intended to play video.");
                    break;
                case 99:
                    //button #6  action:PowerPoint
                    GeneralActions.Speak("To illustrate the point, I understand you selected button six and intended to open a power point presentation.");
                    break;
                case 100:
                    //button #6  action:Word
                    GeneralActions.Speak("To illustrate the point, I understand you selected button six and intended to open a word document.");
                    break;
                case 101:
                    //button #6  action:Excel
                    GeneralActions.Speak("To illustrate the point, I understand you selected button six and intended to open a spreadsheet.");
                    break;
                case 102:
                    //button #6  action:Project
                    GeneralActions.Speak("To illustrate the point, I understand you selected button six and intended to open a project plan.");
                    break;
                case 103:
                    //button #6  action:Undefined
                    GeneralActions.Speak("To illustrate the point, I understand you selected button six and intended to execute the undefined function.");
                    break;
                case 113:
                    //button #7  action:PlayAudio
                    GeneralActions.Speak("To illustrate the point, I understand you selected button seven and intended to play audio.");
                    break;
                case 114:
                    //button #7  action:PlayVideo
                    GeneralActions.Speak("To illustrate the point, I understand you selected button seven and intended to play video.");
                    break;
                case 115:
                    //button #7  action:PowerPoint
                    GeneralActions.Speak("To illustrate the point, I understand you selected button seven and intended to open a power point presentation.");
                    break;
                case 116:
                    //button #7  action:Word
                    GeneralActions.Speak("To illustrate the point, I understand you selected button seven and intended to open a word document.");
                    break;
                case 117:
                    //button #7  action:Excel
                    GeneralActions.Speak("To illustrate the point, I understand you selected button seven and intended to open a spreadsheet.");
                    break;
                case 118:
                    //button #7  action:Project
                    GeneralActions.Speak("To illustrate the point, I understand you selected button seven and intended to open a project plan.");
                    break;
                case 119:
                    //button #7  action:Undefined
                    GeneralActions.Speak("To illustrate the point, I understand you selected button seven and intended to execute the undefined function.");
                    break;
                case 129:
                    //button #8  action:PlayAudio
                    GeneralActions.Speak("To illustrate the point, I understand you selected button eight and intended to play audio.");
                    break;
                case 130:
                    //button #8  action:PlayVideo
                    GeneralActions.Speak("To illustrate the point, I understand you selected button eight and intended to play video.");
                    break;
                case 131:
                    //button #8  action:PowerPoint
                    OfficeActions.StartPresentation(GetFilePath(@"\Resources\Project8\Project Lily.pptx"));
                    break;
                case 132:
                    //button #8  action:Word
                    OfficeActions.OpenWordDocument(GetFilePath(@"\Resources\Project8\Progression of Scenarios.docx"));
                    break;
                case 133:
                    //button #8  action:Excel
                    GeneralActions.Speak("To illustrate the point, I understand you selected button eight and intended to open a spreadsheet.");
                    break;
                case 134:
                    //button #8  action:Project
                    OfficeActions.OpenProjectPlan(GetFilePath(@"\Resources\Project8\Project Kinny Plan.mpp"));
                    break;
                case 135:
                    //button #8  action:Undefined
                    GeneralActions.Speak("To illustrate the point, I understand you selected button eight and intended to execute the undefined function.");
                    break;
                default:
                    GeneralActions.SpeakAsync("Something went wrong evaluating multi modal input.");
                    break;
            }
            //since an action was taken, we can clear the pending action
            //however, the user is still most likely interested in the current context i.e. button clicked => we will leave button selected until something explicitly tells us to change
            return PendingActionResult.ClearPendingAction;
        }

        private static string GetFilePath(string filename)
        {
            StringBuilder str = new StringBuilder();
            str.Append("\"");
            str.Append(@Path.GetDirectoryName(Assembly.GetEntryAssembly().Location));
            str.Append(@filename);
            str.Append("\"");
            return str.ToString();
        }

    }
}
