﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace Actions
{
    public class OfficeActions
    {
        [DllImport("user32.dll")]
        static extern bool SetForegroundWindow(IntPtr hWnd);

        public static void OpenEmptyPowerPoint()
        {
            
        }

        public static void GivePwrPntFocus()
        {
            Process[] procs = Process.GetProcessesByName("POWERPNT");
            SetForegroundWindow(procs[0].MainWindowHandle);
        }

        public static void StartPresentation(string file)
        {
            Process.Start("POWERPNT", file);
        }

        public static void OpenWordDocument(string file)
        {
            Process.Start("WINWORD", file);
        }

        public static void OpenProjectPlan(string file)
        {
            Process.Start("WINPROJ", file);
        }
    }
}
