﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace LilyNUI
{
    public class Histogram
    {
        private long[] rep_histogram;
        public Histogram()
        {
            //default contructor
        }

        public Histogram(Bitmap bitmap)
        {
            rep_histogram = GenerateHistogram(bitmap);
        }

        public static long[] GenerateHistogram(Bitmap bitmap)
        {
            long[] histogram = new long[256];
            for (int i = 0; i < bitmap.Size.Width; i++)
            {
                for (int j = 0; j < bitmap.Size.Height; j++)
                {
                    Color c = bitmap.GetPixel(i, j);
                    long tmp = 0;
                    tmp += c.R;
                    tmp += c.G;
                    tmp += c.B;

                    tmp = (int)tmp / 3;
                    histogram[tmp]++;
                }
            }
            return histogram;
        }
    }
}
